program Lib;
uses crt;
const max=9;
      path='bank.dat';
type  menu=array [1..max] of string;
      info=record
          year,code:integer;
          name,title:string;
      end;
      list=array [0..0] of info;
const pts:menu=('Open file','Save file','Add record','Delete record','Edit record','Sort file','Find record','About','Exit');
var number,current:integer;
    f:file of info;
    l:^list;

procedure InitMenu;
var i      :integer;
begin
    textcolor(green);
    for i:=1 to max do
    begin
        gotoxy(33,7+i);
        write(pts[i]);
    end;
    gotoxy(33,8);
    textcolor(yellow);
    write(pts[1]);
    gotoxy(55,25);
    write('Down-');
    write(chr(25));
    write('     Up - ');
    write(chr(24));
    gotoxy(33,8);
end;

procedure Add;
var f:file of info;
i:integer;
begin
    clrscr;
    inc(number);
    write('Type of bank account: ');
    readln(l^[number].title);
    write('Name: ');
    readln(l^[number].name);
    write('Year: ');
    readln(l^[number].year);
    write('Code: ');
    readln(l^[number].code);
end;

procedure show_part(beg:integer);
var i:integer;
begin
 for i:=1 to 23 do
   begin
         gotoxy(1,i+1);
         write(l^[i+beg-1].title);
         gotoxy(30,i+1);
         write(l^[i+beg-1].name);
         gotoxy(50,i+1);
         write(l^[i+beg-1].year);
         gotoxy(60,i+1);
         write(l^[i+beg-1].code);
  end;
end;

procedure open;
var i,i1:integer;
    f:file of info;
    ch:char;
begin
    clrscr;
    write('Type of bank account: ');
    gotoxy(58,25);
    write('Down-');
    write(chr(25));
    write('  Up-');
    write(chr(24));
    write('  Ent-Exit');
    gotoxy(30,1);
    write('Name');
    gotoxy(50,1);
    write('Year');
    gotoxy(60,1);
    write('Code');
    i:=1;
    repeat
      show_part(i);
      ch:=readkey;
      i1:=integer(ch);
       case i1 of
        72 : begin if i>1 then i:=i-1;end;
        80 : begin if i+22<number then i:=i+1;end;
      end;
    until i1=13;
end;

procedure save;
var f:file of info;
    i:integer;
begin
    assign(f,path);
    rewrite(f);
    for i:=1 to number do
       write(f,l^[i]);
    close(f);
end;

procedure delete;
var i,j:integer;
f:file of info;
begin
    clrscr;
    write('Code: ');
    readln(j);
    for i:=1 to number+current do
        if(l^[i].code=j) then
             break;
    if(i<number) or ((i=number) and (l^[i].code=j))  then
    begin
        j:=i;
        for i:=j to number-1 do
            l^[i]:=l^[i+1];
        dec(number);
    end
    else
    begin
        write('Client not found!');
        readkey;
    end;
end;

procedure Find;
var i,j:integer;
begin
    clrscr;
    write('Code: ');
    readln(j);
    clrscr;
    for i:=1 to number do
        if(l^[i].code=j) then
             break;
    if(i<number) or ((i=number) and (l^[i].code=j))  then
    begin
          write('Type of bank account: ');
          writeln(l^[i].title);
          write('Name: ');
          writeln(l^[i].name);
          write('Year: ');
          writeln(l^[i].year);
          write('Code: ');
          writeln(l^[i].code);
          readkey;
    end
    else
    begin
        write('Client not found!');
        readkey;
    end;
end; 

procedure about;
begin
    clrscr;
    gotoxy(30,11);
    write('Bank client base.2010');
    readkey;
end;

procedure edit;
var i,j:integer;
begin
    clrscr;
    write('Code: ');
    readln(j);
    clrscr;
    for i:=1 to number do
       if(l^[i].code=j) then
       break;
    if(i<number) or ((i=number) and (l^[i].code=j))  then
    begin
          write('Type of bank account: ');
          writeln(l^[i].title);
          write('Name: ');
          writeln(l^[i].name);
          write('Year: ');
          writeln(l^[i].year);
          write('Code: ');
          writeln(l^[i].code);
    end
    else
    begin
        write('Client not found!');
        readkey;
        exit;
    end;
    writeln;
    write('Type of bank account: ');
    readln(l^[i].title);
    write('Name: ');
    readln(l^[i].name);
    write('Year: ');
    readln(l^[i].year);
    write('Code: ');
    readln(l^[i].code);
end;

function less(s1,s2:string):boolean;
var l,i:integer;
begin
    l:=length(s1);
    if(l>length(s2)) then
       l:=length(s2);
    for i:=1 to l do
       if(s1[i]>s2[i]) then
       begin
           less:=false;
           exit;
       end
       else
       begin
           less:=true;
           exit;
       end;
end;

procedure convers(var i1,i2:info);
var temp:info;
begin
    temp:=i1;
    i1:=i2;
    i2:=temp;
end;

procedure sortname;
var count,i:integer;
begin
    repeat
    begin
       count:=0;
       for i:=1 to number-1 do
          if(less(l^[i].name,l^[i+1].name)=false) then
          begin
              convers(l^[i],l^[i+1]);
              inc(count);
          end;
    end
    until count=0;
end;

procedure sorttitle;
var count,i:integer;
begin
    repeat
    begin
       count:=0;
       for i:=1 to number-1 do
          if(less(l^[i].title,l^[i+1].title)=false) then
          begin
              convers(l^[i],l^[i+1]);
              inc(count);
          end;
    end
    until count=0;
end;

procedure sortyear;
var count,i:integer;
begin
    repeat
    begin
       count:=0;
       for i:=1 to number-1 do
          if(l^[i].year>l^[i+1].year) then
          begin
              convers(l^[i],l^[i+1]);
              inc(count);
          end;
    end
    until count=0;
end;

procedure sortcode;
var count,i:integer;
begin
    repeat
    begin
       count:=0;
       for i:=1 to number-1 do
          if(l^[i].code>l^[i+1].code) then
          begin
              convers(l^[i],l^[i+1]);
              inc(count);
          end;
    end
    until count=0;
end;

procedure sort;
var ch:char;
begin
    clrscr;
    repeat
    begin
        write('Choose sort key(1-name,2-title,3-year,4-code): ');
        readln(ch);
    end
    until ((ch='1') or (ch='2') or (ch='3') or (ch='4'));
    case integer(ch) of
    49: sortname;

    50: sorttitle;

    51: sortyear;

    52: sortcode;

    end;
end;


procedure Dispatch;
var ch:char;
    int,x,y:integer;
begin
    x:=wherex;
    y:=wherey;
    ch:=readkey;
    if(ch=#0) then
        ch:=readkey;
    int:=integer(ch);
    case int of
    72  : begin
              if (y-7)<>1 then
              begin
                  textcolor(green);
                  gotoxy(33,y);
                  write(pts[y-7]);
                  dec(y);
                  gotoxy(33,y);
                  textcolor(yellow);
                  write(pts[y-7]);
                  textcolor(green);
              end;
              dispatch;
         end;
    80 : begin
              if (y-7)<>max then
              begin
                  textcolor(green);
                  gotoxy(33,y);
                  write(pts[y-7]);
                  inc(y);
                  gotoxy(33,y);
                  textcolor(yellow);
                  write(pts[y-7]);
                  textcolor(green);
              end;
              dispatch;
          end;
    13 :  begin
             case (y-7) of
               max:
               begin
                   clrscr;
                   gotoxy(23,10);
                   write('Exit:are you sure? y/n:');
                   ch:=readkey;
                   if (ch<>'y') and (ch<>'Y')  then
                   begin
                       clrscr;
                       initmenu;
                       dispatch;
                   end
                   else
                   begin
                       writeln;
                       gotoxy(23,11);
                       write('Save all? y/n:');
                       ch:=readkey;
                       if (ch='y') or (ch='Y') then
                          { save;    }
                       exit;
                       dispatch;
                   end;
               end;
               3:
               begin
                   add;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               4:
               begin
                   delete;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               1:
               begin
                   open;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               2:
               begin
                   save;
                   dispatch;
               end;
               7:
               begin
                   find;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               8:
               begin
                   about;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               5:
               begin
                   edit;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
               6:
               begin
                   sort;
                   clrscr;
                   initmenu;
                   dispatch;
               end;
         end;
    end;
    else dispatch;
    end;
end;

var i,err:integer;
begin
    clrscr;
    textcolor(green);
    assign(f,path);
    {$I-}
    reset(f);
    {$I+}
    err:=ioresult;
    if(err<>0) then
    rewrite(f);
    number:=filesize(f);
    getmem(l,number*sizeof(info));
    for i:=1 to number do
        read(f,l^[i]);
    close(f);
    initmenu;
    dispatch;
    freemem(l,number*sizeof(info));
end.
